ifndef trigger_wdl;
define trigger_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 5.0
// engineReq: 6.4
// date: 061011
//
// title: Trigger (00)
// class: MISC
// type: USER
// image: trigger00.pcx
// help: Handle "triggers". Triggers can be used to activate/deactivate other
// help:objects like doors, lifts, particle generators, etc.
//
//
// needs: gid01.wdl, plSelect.wdl
//
// external:
//
// prefix: trigger00_
// idcode: 022
//
// ENDHEADER
// ---------------------------------------------------------------------


// enable: print "debug output" for player on screen?
// id: 1
// define TRIGGER00_DEBUG;

//----------------------------------------------------------------------
// Skill
define	_id__022,SKILL1;	// the value of this trigger (1-trigger00_max_value_const*trigger00_bitlist_size_const)
define	_recycle_time__022,SKILL2;	// time (seconds) to recycle the trigger
define 	_trigger_range__022,SKILL3; // range to automaticly activate trigger
define	_pre_id__022, SKILL4;		// id of a required trigger value to activate this trigger
define	_reset_id__022, SKILL5;		// reset the trigger with this id in addition to other action

define	_auto_off__022, SKILL14;	// if set greater than 0, the trigger will turn itself off after time (sec)

// triggered objects
define	_on_frames__022,  SKILL6;	  	// frames of "on" animation
define	_on_speed__022,   SKILL7;	  	// speed of "on" animation
define	_idle_frames__022,SKILL8;		// frames of "idle" animation (after on)
define	_idle_speed__022, SKILL9;     // speed of "idle" animation
define	_off_frames__022,SKILL10;		// frames of "off" animation (after idle)
define	_off_speed__022, SKILL11;		// speed of "off" animation

// display elements
define	_pscan_icon__022, SKILL12;		// ID of passive scan icon

//----------------------------------------------------------------------
// Flags
define	_flip_trigger__022, flag1;	// "flip" the trigger value (1->0 0->1)
define	_reset_trigger__022,flag2; // turn off the trigger value (1->0, 0->0)
// note: the default is 'set' (1->1, 0->1)

define	_only_once__022, flag3;		// remove this trigger after it is used

define	_use_trigger_range__022, flag4; // use trigger box
define	_ignore_scan__022, flag5;  // ignore scans
define	_use_sonar__022,	flag6;   // activate on sonar
define	_ignore_click__022,flag7;  // ignore left mouse click
define	_ignore_impact__022,flag8;	// ignore impact with player

define	_busy__022, flag8;			// <internal> this trigger is 'busy'

define	trigger00_max_value_const = 22;  		// maximum number of triggers in each block
define	trigger00_max_block_const = 1024;		// maximum number of blocks (array size)
define	trigger00_bitlist_size_const = 6;		// size of the local bitlist

// with the array size set to 6 you can have up to 134 flags
var	trigger00_bitlist[trigger00_bitlist_size_const];	// bit encoded list of active triggers (up to trigger00_max_value_const)

//----------------------------------------------------------------------
// section: Passive Icon #1

// entry: Bitmap
// id: 14
bmap trigger00_picon1_bmp = <icon1.pcx>;


panel trigger00_PassiveIcon1_Pan
{
	bmap = trigger00_picon1_bmp;
// entry: Icon X position
// id: 15
	pos_X = 200;
// entry: Icon Y position
// id: 16
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #2
// entry: Bitmap
// id: 17
bmap trigger00_picon2_bmp = <icon2.pcx>;


panel trigger00_PassiveIcon2_Pan
{
	bmap = trigger00_picon2_bmp;
// entry: Icon X position
// id: 18
	pos_X = 200;
// entry: Icon Y position
// id: 19
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #3
// entry: Bitmap
// id: 20
bmap trigger00_picon3_bmp = <icon3.pcx>;


panel trigger00_PassiveIcon3_Pan
{
	bmap = trigger00_picon3_bmp;
// entry: Icon X position
// id: 21
	pos_X = 200;
// entry: Icon Y position
// id: 22
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #4
// entry: Bitmap
// id: 23
bmap trigger00_picon4_bmp = <icon4.pcx>;


panel trigger00_PassiveIcon4_Pan
{
	bmap = trigger00_picon4_bmp;
// entry: Icon X position
// id: 24
	pos_X = 200;
// entry: Icon Y position
// id: 25
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #5

// entry: Bitmap
// id: 26
bmap trigger00_picon5_bmp = <icon1.pcx>;


panel trigger00_PassiveIcon5_Pan
{
	bmap = trigger00_picon5_bmp;
// entry: Icon X position
// id: 27
	pos_X = 200;
// entry: Icon Y position
// id: 28
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #6

// entry: Bitmap
// id: 29
bmap trigger00_picon6_bmp = <icon2.pcx>;


panel trigger00_PassiveIcon6_Pan
{
	bmap = trigger00_picon6_bmp;
// entry: Icon X position
// id: 30
	pos_X = 200;
// entry: Icon Y position
// id: 31
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #7

// entry: Bitmap
// id: 32
bmap trigger00_picon7_bmp = <icon3.pcx>;


panel trigger00_PassiveIcon7_Pan
{
	bmap = trigger00_picon7_bmp;
// entry: Icon X position
// id: 33
	pos_X = 200;
// entry: Icon Y position
// id: 34
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Passive Icon #8

// entry: Bitmap
// id: 35
bmap trigger00_picon8_bmp = <icon4.pcx>;


panel trigger00_PassiveIcon8_Pan
{
	bmap = trigger00_picon8_bmp;
// entry: Icon X position
// id: 36
	pos_X = 200;
// entry: Icon Y position
// id: 37
	pos_y = 4;
	flags = overlay,refresh;
}



//----------------------------------------------------------------------
// section: Active Trigger Icon #1

// entry: Trigger value
// help: When this trigger is set, the icon will appear on screen
// cntl: spin 0 x 1
// id: 2
var	trigger00_icon1_value = 0;

// entry: Bitmap
// id: 3
bmap trigger00_icon1_bmp = <icon1.pcx>;


panel trigger00_Icon1_Pan
{
	bmap = trigger00_icon1_bmp;
// entry: Icon X position
// id: 4
	pos_X = 200;
// entry: Panel Y position
// id: 5
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Active Trigger Icon #2

// entry: Trigger value
// help: When this trigger is set, the icon will appear on screen
// cntl: spin 0 x 1
// id: 6
var	trigger00_icon2_value = 0;

// entry: Bitmap
// id: 7
bmap trigger00_icon2_bmp = <icon2.pcx>;


panel trigger00_Icon2_Pan
{
	bmap = trigger00_icon2_bmp;
// entry: Icon X position
// id: 8
	pos_X = 260;
// entry: Panel Y position
// id: 9
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------
// section: Active Trigger Icon #3

// entry: Trigger value
// help: When this trigger is set, the icon will appear on screen
// cntl: spin 0 x 1
// id: 10
var	trigger00_icon3_value = 0;

// entry: Bitmap
// id: 11
bmap trigger00_icon3_bmp = <icon3.pcx>;


panel trigger00_Icon3_Pan
{
	bmap = trigger00_icon3_bmp;
// entry: Icon X position
// id: 12
	pos_X = 320;
// entry: Panel Y position
// id: 13
	pos_y = 4;
	flags = overlay,refresh;
}

//----------------------------------------------------------------------


ifdef TRIGGER00_DEBUG;
font trigger00_debug_font = <ackfont.pcx>,6,9;
text trigger00_debug_txt
{
     font = trigger00_debug_font;
     pos_x = 200;
     pos_y = 1;
     string =
	   "Trigger Stats\n============\n->1\n->2\n->3\n->4\n->5\n\n->6\n->7\n->8\n->9\n->10\n\n->11\n->12\n->13\n->14\n->15\n\n->16\n->17\n->18\n->19\n->20\n\n->21\n->22";

     flags = d3d, visible;
}
var  trigger00_debug_data[23];
panel trigger00_debug_pan
{
	pos_x = 170;
	pos_y = 10;
	digits = 0, 9, 5, trigger00_debug_font, 1, trigger00_debug_data[0];  //
	digits = 0, 18, 5, trigger00_debug_font, 1, trigger00_debug_data[1];	//
	digits = 0, 27, 5, trigger00_debug_font, 1, trigger00_debug_data[2]; //
	digits = 0, 36, 5, trigger00_debug_font, 1, trigger00_debug_data[3]; //
	digits = 0, 45, 5, trigger00_debug_font, 1, trigger00_debug_data[4]; //

	digits = 0, 63, 5, trigger00_debug_font, 1, trigger00_debug_data[5]; //
	digits = 0, 72, 5, trigger00_debug_font, 1, trigger00_debug_data[6]; //
	digits = 0, 81, 5, trigger00_debug_font, 1, trigger00_debug_data[7]; //
	digits = 0, 90, 5, trigger00_debug_font, 1, trigger00_debug_data[8]; //
	digits = 0, 99, 5, trigger00_debug_font, 1, trigger00_debug_data[9]; //

	digits = 0, 117, 5, trigger00_debug_font, 1, trigger00_debug_data[10];
	digits = 0, 126, 5, trigger00_debug_font, 1, trigger00_debug_data[11];
	digits = 0, 135, 5, trigger00_debug_font, 1, trigger00_debug_data[12];
	digits = 0, 144, 5, trigger00_debug_font, 1, trigger00_debug_data[13];
	digits = 0, 153, 5, trigger00_debug_font, 1, trigger00_debug_data[14];

	digits = 0, 171, 5, trigger00_debug_font, 1, trigger00_debug_data[15];
	digits = 0, 180, 5, trigger00_debug_font, 1, trigger00_debug_data[16];
	digits = 0, 189, 5, trigger00_debug_font, 1, trigger00_debug_data[17];
	digits = 0, 198, 5, trigger00_debug_font, 1, trigger00_debug_data[18];
	digits = 0, 207, 5, trigger00_debug_font, 1, trigger00_debug_data[19];

	digits = 0, 225, 5, trigger00_debug_font, 1, trigger00_debug_data[20];
	digits = 0, 234, 5, trigger00_debug_font, 1, trigger00_debug_data[21];
	digits = 0, 234, 5, trigger00_debug_font, 1, trigger00_debug_data[22];
	flags = refresh, d3d, visible;

}
var  trigger00_debug_data_2[22];
panel trigger00_debug_pan_2
{
	pos_x = 210;
	pos_y = 10;
	digits = 0, 9, 5, trigger00_debug_font, 1, trigger00_debug_data_2[0];  //
	digits = 0, 18, 5, trigger00_debug_font, 1, trigger00_debug_data_2[1];	//
	digits = 0, 27, 5, trigger00_debug_font, 1, trigger00_debug_data_2[2]; //
	digits = 0, 36, 5, trigger00_debug_font, 1, trigger00_debug_data_2[3]; //
	digits = 0, 45, 5, trigger00_debug_font, 1, trigger00_debug_data_2[4]; //

	digits = 0, 63, 5, trigger00_debug_font, 1, trigger00_debug_data_2[5]; //
	digits = 0, 72, 5, trigger00_debug_font, 1, trigger00_debug_data_2[6]; //
	digits = 0, 81, 5, trigger00_debug_font, 1, trigger00_debug_data_2[7]; //
	digits = 0, 90, 5, trigger00_debug_font, 1, trigger00_debug_data_2[8]; //
	digits = 0, 99, 5, trigger00_debug_font, 1, trigger00_debug_data_2[9]; //

	digits = 0, 117, 5, trigger00_debug_font, 1, trigger00_debug_data_2[10];
	digits = 0, 126, 5, trigger00_debug_font, 1, trigger00_debug_data_2[11];
	digits = 0, 135, 5, trigger00_debug_font, 1, trigger00_debug_data_2[12];
	digits = 0, 144, 5, trigger00_debug_font, 1, trigger00_debug_data_2[13];
	digits = 0, 153, 5, trigger00_debug_font, 1, trigger00_debug_data_2[14];

	digits = 0, 171, 5, trigger00_debug_font, 1, trigger00_debug_data_2[15];
	digits = 0, 180, 5, trigger00_debug_font, 1, trigger00_debug_data_2[16];
	digits = 0, 189, 5, trigger00_debug_font, 1, trigger00_debug_data_2[17];
	digits = 0, 198, 5, trigger00_debug_font, 1, trigger00_debug_data_2[18];
	digits = 0, 207, 5, trigger00_debug_font, 1, trigger00_debug_data_2[19];

	digits = 0, 225, 5, trigger00_debug_font, 1, trigger00_debug_data_2[20];
	digits = 0, 234, 5, trigger00_debug_font, 1, trigger00_debug_data_2[21];
	flags = refresh, d3d, visible;

}
var  trigger00_debug_data_6[22];
panel trigger00_debug_pan_6
{
	pos_x = 270;
	pos_y = 10;
	digits = 0,  9, 5, trigger00_debug_font, 1, trigger00_debug_data_6[0];  //
	digits = 0, 18, 5, trigger00_debug_font, 1, trigger00_debug_data_6[1];	//
	digits = 0, 27, 5, trigger00_debug_font, 1, trigger00_debug_data_6[2]; //
	digits = 0, 36, 5, trigger00_debug_font, 1, trigger00_debug_data_6[3]; //
	digits = 0, 45, 5, trigger00_debug_font, 1, trigger00_debug_data_6[4]; //

	digits = 0, 63, 5, trigger00_debug_font, 1, trigger00_debug_data_6[5]; //
	digits = 0, 72, 5, trigger00_debug_font, 1, trigger00_debug_data_6[6]; //
	digits = 0, 81, 5, trigger00_debug_font, 1, trigger00_debug_data_6[7]; //
	digits = 0, 90, 5, trigger00_debug_font, 1, trigger00_debug_data_6[8]; //
	digits = 0, 99, 5, trigger00_debug_font, 1, trigger00_debug_data_6[9]; //

	digits = 0, 117, 5, trigger00_debug_font, 1, trigger00_debug_data_6[10];
	digits = 0, 126, 5, trigger00_debug_font, 1, trigger00_debug_data_6[11];
	digits = 0, 135, 5, trigger00_debug_font, 1, trigger00_debug_data_6[12];
	digits = 0, 144, 5, trigger00_debug_font, 1, trigger00_debug_data_6[13];
	digits = 0, 153, 5, trigger00_debug_font, 1, trigger00_debug_data_6[14];

	digits = 0, 171, 5, trigger00_debug_font, 1, trigger00_debug_data_6[15];
	digits = 0, 180, 5, trigger00_debug_font, 1, trigger00_debug_data_6[16];
	digits = 0, 189, 5, trigger00_debug_font, 1, trigger00_debug_data_6[17];
	digits = 0, 198, 5, trigger00_debug_font, 1, trigger00_debug_data_6[18];
	digits = 0, 207, 5, trigger00_debug_font, 1, trigger00_debug_data_6[19];

	digits = 0, 225, 5, trigger00_debug_font, 1, trigger00_debug_data_6[20];
	digits = 0, 234, 5, trigger00_debug_font, 1, trigger00_debug_data_6[21];
	flags = refresh, d3d, visible;

}

starter	trigger00_update_debug()
{
	var count;

	while(1)
	{
		count = 0;
		while(count < 22)
		{
			trigger00_debug_data[count] = trigger00_bitlist[0] & (1<<(count));
			trigger00_debug_data_2[count] = trigger00_bitlist[1] & (1<<(count));
			trigger00_debug_data_6[count] = trigger00_bitlist[5] & (1<<(count));
			count += 1;
		}
		wait(1);
	}

}
endif;  // end debug code

// NOTE: "trigger blocks" indicate the size of the array used to store trigger values.
//  The trigger block value is encoded in the FRC part of the first value in the array.
// The value can be 0 - 1024

//		jack = temp>>10;
//		jack = FRC(jack)<<10;

// Desc: reset the trigger list
function	Trigger00_Reset_All(&bitlist)
{
	temp[1] = FRC(bitlist[0]) << 10;	// get number of "trigger blocks"
	temp[0] = temp[1] - 1; // store the value to restore later
	while(temp >= 0)
	{
		bitlist[temp] = 0;
   	temp -= 1;
	}
	bitlist[0] = (temp[1]>>10);	// put the count back
}

// Desc: set a single trigger value
function	Trigger00_Set(nTrigger,&bitlist)
{
	nTrigger = INT(nTrigger); // only works with ints

	if(nTrigger<1) {return(-1);} // out of range (low)

	temp[0] = FRC(bitlist[0]) << 10;	// get number of "trigger blocks"
	temp[1] = 0;	// starting index
	while(nTrigger>trigger00_max_value_const)
	{
		nTrigger -= trigger00_max_value_const;
		temp[1] += 1;
		if(temp[1] > temp[0]) { return(-2); } // out of range (high)
	}


	bitlist[temp[1]] |= (1<<(nTrigger-1));
}

// Desc: reset a single trigger value
function	Trigger00_Reset(nTrigger,&bitlist)
{
	if(nTrigger<1) { return(-1); } // out of range (low)

	temp[0] = FRC(bitlist[0]) << 10;	// get number of "trigger blocks"
	temp[1] = 0;	// starting index
	while(nTrigger>trigger00_max_value_const)
	{
		nTrigger -= trigger00_max_value_const;
		temp[1] += 1;
		if(temp[1] > temp[0]) { return(-2); } // out of range (high)
	}

	temp[2] = (1<<(nTrigger-1));
	if( bitlist[temp[1]] & temp[2])  // make sure it has been set
	{
		bitlist[temp[1]] ^= temp[2];
	}
}

// Desc: Flip a single trigger value
function  Trigger00_Flip(nTrigger,&bitlist)
{
	if(nTrigger<1) { return(-1); } // out of range (low)

	temp[0] = FRC(bitlist[0]) << 10;	// get number of "trigger blocks"
	temp[1] = 0;	// starting index
	while(nTrigger>trigger00_max_value_const)
	{
		nTrigger -= trigger00_max_value_const;
		temp[1] += 1;
		if(temp[1] > temp[0]) { return(-2); } // out of range (high)
	}

	bitlist[temp[1]] ^= (1<<(nTrigger-1));
}


// Desc: return 1 is trigger is set, otherwise 0
function	Trigger00_Check(nTrigger,&bitlist)
{
 	if(nTrigger<1) { return(-1); } // out of range (low)

	temp[0] = FRC(bitlist[0]) << 10;	// get number of "trigger blocks"
	temp[1] = 0;	// starting index
	while(nTrigger>trigger00_max_value_const)
	{
		nTrigger -= trigger00_max_value_const;
		temp[1] += 1;
		if(temp[1] > temp[0]) { return(-2); } // out of range (high)
	}

	if( bitlist[temp[1]] & (1<<(nTrigger-1)) ) {  return(1); }
	else { return(0); }
}

// Desc: Check to see if any icons need to be turned on or off
function Trigger00_Check_Icons()
{
	if(Trigger00_Check(trigger00_icon1_value,trigger00_bitlist) == 1)
	{
		trigger00_Icon1_Pan.visible = on;
	}
	else
	{
		trigger00_Icon1_Pan.visible = off;
	}

	if(Trigger00_Check(trigger00_icon2_value,trigger00_bitlist) == 1)
	{
		trigger00_Icon2_Pan.visible = on;
	}
	else
	{
		trigger00_Icon2_Pan.visible = off;
	}

	if(Trigger00_Check(trigger00_icon3_value,trigger00_bitlist) == 1)
	{
		trigger00_Icon3_Pan.visible = on;
	}
	else
	{
		trigger00_Icon3_Pan.visible = off;
	}

}

var	trigger00_PIcon_cnt[8] = 0;

// Desc: Display a "passive scan" icon for one frame
// Note: we need a counter so we don't turn off the icon on the same frame we turn it on...
function	Trigger00_Show_PassiveIcons(id)
{
	if(id <= 1)
	{
		if(trigger00_PIcon_cnt[0] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon1_Pan,clib_panel_center,bmap_width(trigger00_picon1_bmp),bmap_height(trigger00_picon1_bmp));
		}
		trigger00_PassiveIcon1_Pan.visible = on;
		trigger00_PIcon_cnt[0] += 1;
		wait(1);

		trigger00_PIcon_cnt[0] -= 1;
  		if(trigger00_PIcon_cnt[0] <= 0)
		{
			trigger00_PassiveIcon1_Pan.visible = off;
		}
		return;
	}

	if(id <= 2)
	{
		if(trigger00_PIcon_cnt[1] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon2_Pan,clib_panel_center,bmap_width(trigger00_picon2_bmp),bmap_height(trigger00_picon2_bmp));
		}
		trigger00_PassiveIcon2_Pan.visible = on;
		trigger00_PIcon_cnt[1] += 1;
		wait(1);

		trigger00_PIcon_cnt[1] -= 1;
  		if(trigger00_PIcon_cnt[1] <= 0)
		{
			trigger00_PassiveIcon2_Pan.visible = off;
		}
		return;
	}

	if(id <= 3)
	{
		if(trigger00_PIcon_cnt[2] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon3_Pan,clib_panel_center,bmap_width(trigger00_picon3_bmp),bmap_height(trigger00_picon3_bmp));
		}
		trigger00_PassiveIcon3_Pan.visible = on;
		trigger00_PIcon_cnt[2] += 1;
		wait(1);

		trigger00_PIcon_cnt[2] -= 1;
  		if(trigger00_PIcon_cnt[2] <= 0)
		{
			trigger00_PassiveIcon3_Pan.visible = off;
		}
		return;
	}

	if(id <= 4)
	{
		if(trigger00_PIcon_cnt[3] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon4_Pan,clib_panel_center,bmap_width(trigger00_picon4_bmp),bmap_height(trigger00_picon4_bmp));
		}
		trigger00_PassiveIcon4_Pan.visible = on;
		trigger00_PIcon_cnt[3] += 1;
		wait(1);

		trigger00_PIcon_cnt[3] -= 1;
  		if(trigger00_PIcon_cnt[3] <= 0)
		{
			trigger00_PassiveIcon4_Pan.visible = off;
		}
		return;
	}

	if(id <= 5)
	{
		if(trigger00_PIcon_cnt[4] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon5_Pan,clib_panel_center,bmap_width(trigger00_picon5_bmp),bmap_height(trigger00_picon5_bmp));
		}
		trigger00_PassiveIcon5_Pan.visible = on;
		trigger00_PIcon_cnt[4] += 1;
		wait(1);

		trigger00_PIcon_cnt[4] -= 1;
  		if(trigger00_PIcon_cnt[4] <= 0)
		{
			trigger00_PassiveIcon5_Pan.visible = off;
		}
		return;
	}

	if(id <= 6)
	{
		if(trigger00_PIcon_cnt[5] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon6_Pan,clib_panel_center,bmap_width(trigger00_picon6_bmp),bmap_height(trigger00_picon6_bmp));
		}
		trigger00_PassiveIcon6_Pan.visible = on;
		trigger00_PIcon_cnt[5] += 1;
		wait(1);

		trigger00_PIcon_cnt[5] -= 1;
  		if(trigger00_PIcon_cnt[5] <= 0)
		{
			trigger00_PassiveIcon6_Pan.visible = off;
		}
		return;
	}

	if(id <= 7)
	{
		if(trigger00_PIcon_cnt[6] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon7_Pan,clib_panel_center,bmap_width(trigger00_picon7_bmp),bmap_height(trigger00_picon7_bmp));
		}
		trigger00_PassiveIcon7_Pan.visible = on;
		trigger00_PIcon_cnt[6] += 1;
		wait(1);

		trigger00_PIcon_cnt[6] -= 1;
  		if(trigger00_PIcon_cnt[6] <= 0)
		{
			trigger00_PassiveIcon7_Pan.visible = off;
		}
		return;
	}

	if(id <= 8)
	{
		if(trigger00_PIcon_cnt[7] <= 0)
		{
			// only need to position once each time it becomes visible
			Clib_Panel_Position(trigger00_PassiveIcon8_Pan,clib_panel_center,bmap_width(trigger00_picon8_bmp),bmap_height(trigger00_picon8_bmp));
		}
		trigger00_PassiveIcon8_Pan.visible = on;
		trigger00_PIcon_cnt[7] += 1;
		wait(1);

		trigger00_PIcon_cnt[7] -= 1;
  		if(trigger00_PIcon_cnt[7] <= 0)
		{
			trigger00_PassiveIcon8_Pan.visible = off;
		}
		return;
	}


}


//----------------------------------------------------------------------
// Event handler

// Wait a set amount of time, then turn this trigger off
function	Trigger00_AutoOff(trigger_id, wait_time)
{
	sleep(wait_time);
	Trigger00_Reset(trigger_id,trigger00_bitlist);
}

// Event handler for trigger object
function	Trigger00_Event()
{

	// make sure this is the player
	if(YOU != plSelect_curr_ent) { return; }

	if(my._busy__022 == ON)	// already doing something
	{
		return;
	}

	if(event_scan == event_type)
	{
		// handle passive scans
		if(gid01_event_scan_passive == gid01_event_type)
		{
			if(my._pscan_icon__022 > 0)
			{
				Trigger00_Show_PassiveIcons(my._pscan_icon__022);
			}

		}

		// only activate on "activate" scans
		if(gid01_event_scan_activate != gid01_event_type)
 		{
			return;
		}
	}


	if(my._pre_id__022 > 0)  // uses a "pre-trigger"
	{
		// check to see if this trigger has been switch
		if(Trigger00_Check(my._pre_id__022,trigger00_bitlist) == 0)
		{
			// pre-trigger not set yet...
			return;
		}
	}


	my._busy__022 = ON;
	if(1 == my._flip_trigger__022) { Trigger00_Flip(my._id__022,trigger00_bitlist); }
	else
	{
		if(1 == my._reset_trigger__022) { Trigger00_Reset(my._id__022,trigger00_bitlist); }
		else { Trigger00_Set(my._id__022,trigger00_bitlist); }
	}

	// reset another trigger (if set)
	if(my._reset_id__022 > 0)
	{
		Trigger00_Reset(my._reset_id__022,trigger00_bitlist);
	}

	// see if any of the Icons need to be turned on or off...
	Trigger00_Check_Icons();

	// does this trigger turn itself off?
	if(my._auto_off__022 > 0)	{ Trigger00_AutoOff(my._id__022, my._auto_off__022); }

	sleep(my._recycle_time__022);
	my._busy__022 = OFF;

	// use only once?
	if(1==my._only_once__022)
	{
		// remove from level
		my.passable = on;
		my.event = NULL;
		my.enable_scan = off;
		my.enable_click = off;
		my.enable_sonar = off;
		my.enable_impact = off;
		wait(1);
		ent_remove(me);
	}
}

//----------------------------------------------------------------------
// Starter

starter	Trigger00_Init()
{
	trigger00_bitlist = (trigger00_bitlist_size_const-1)>>10;	//
	Trigger00_Reset_All(trigger00_bitlist); // reset the bitlist
}


//----------------------------------------------------------------------
// Actions


// action: Trigger00
// title: Basic Trigger
// Desc: Basic trigger object
// help:	Unless specified otherwise, basic trigger objects set a flag value to 'on' if the player impacts, scans, or clicks on it.
//
// uses: _id__022, _recycle_time__022, _trigger_range__022
// uses: _pre_id__022, _reset_id__022
// uses: _ignore_scan__022, _use_sonar__022, _ignore_click__022
// uses: _use_trigger_range__022, _flip_trigger__022, _reset_trigger__022
// uses: _only_once__022, _ignore_impact__022, _pscan_icon__022, _auto_off__022
//
//------------------
// section: ID Values
//	skill1: ID 1
// cntl: spin 1 x 1
// help: ID of trigger that this entity sets/resets.
//
// skill4: PreTriggerID 0
// cntl: spin 0 x 1
// help: ID of another trigger that must be active *before* this trigger can be active.
//
// skill5: ResetID 0
// cntl: spin 0 x 1
// help: ID of a trigger that is reset.
// help: Note: This is in addition to whatever ID this entity is setting/reseting.
//
// skill14: AutoOffTime 0
// cntl: spin 0 x 1
// help: Trigger only stays active for this number of seconds.
// help: (if the value is 0, the trigger doesn't turn itself off)
//
// flag1: FlipTrigger 0
// section: Action
// help: Flip to trigger value on each use (on->off, off->on).
//
// flag2: ResetTrigger 0
// help: Turn off the trigger on use (on->off, off->off).
//
// flag3: OnceOnly 0
// help: Remove this entity after use.
//
// -------------------------------------------------
// section: Activation
// skill3: TriggerRange 0
// cntl: spin 0 x 1
// help: Range (quants) to detect triggering entities (e.g. the player).
//
// flag4: UseTriggerRange 0
// help: Trigger on "trigger range" event.
//
// flag5: IgnoreScan 0
// help: Don't detect "scans".
//
// flag8: IgnoreImpact 0
// help: Don't detect "impact" events.
//
// flag7: IgnoreClick 0
// help: Don't detect "mouse click" events.
//
// flag6: UseSonar 0
// help: Activate on "sonar".
//
// skill2: RecycleTime 1
// cntl: spin 0 x 1
// help: Min time (seconds) between activations.
//
// --------------------------------------------------
// section: Icon
// skill12: PScanIcon 0
// cntl: spin 0 8 1
// help: Icon displayed when passive scanned.
action Trigger00
{
	// cap value to min/max
	if(my._id__022 < 1)  { my._id__022 = 1; }
	if(my._id__022 > (trigger00_max_value_const*trigger00_bitlist_size_const))
	{
		my._id__022 = (trigger00_max_value_const*trigger00_bitlist_size_const);
	}

	// set up events
	my.event = Trigger00_Event;
	if( (0 < my._trigger_range__022) || (1 == my._use_trigger_range__022))
	{
		my.trigger_range = my._trigger_range__022;
		my.enable_trigger = on;
	}


	if( 0 == my._ignore_scan__022) { my.enable_scan = on; }
	if( 1 == my._use_sonar__022) { my.enable_sonar = on; }
	if( 0 == my._ignore_click__022) { my.enable_click = on; }
	if( 0 == my._ignore_impact__022) { my.enable_impact = on; }
	else { my._ignore_impact__022 = 0; } // needs to be reset because this is also the _busy__022 flag
}




// action: Trigger00_Volume
// title: Trigger Volume
// Desc: Trigger volume object
//		Attach to a passable map entity you wish to use to activate a trigger.
//
// uses: _id__022
// uses: _recycle_time__022,
// uses: _flip_trigger__022, _reset_trigger__022
// uses: _only_once__022, _auto_off__022
//
//------------------
// section: ID Values
//	skill1: ID 1
// cntl: spin 1 x 1
// help: ID of trigger that this entity sets/resets.
//
// skill2: RecycleTime 1
// cntl: spin 0 x 1
// help: Min time (seconds) between activations.
//
// skill14: AutoOffTime 0
// cntl: spin 0 x 1
// help: Trigger only stays active for this number of seconds.
// help: (if the value is 0, the trigger doesn't turn itself off)
//
//------------------
// section: Action
// flag1: FlipTrigger 0
// help: Flip to trigger value on each use (on->off, off->on).
//
// flag2: ResetTrigger 0
// help: Turn off the trigger on use (on->off, off->off).
//
// flag3: OnceOnly 0
// help: Remove this entity after use.
//
action	Trigger00_Volume
{
	// cap value to min/max
	if(my._id__022 < 1)  { my._id__022 = 1; }
	if(my._id__022 > (trigger00_max_value_const*trigger00_bitlist_size_const))
	{
		my._id__022 = (trigger00_max_value_const*trigger00_bitlist_size_const);
	}

	// set up events
	my.event = Trigger00_Event;
	my.trigger_range = 0;
	my.enable_trigger = on;
	my.passable = on;
}


// action: Trigger00_RMObj
// title: Trigger Removable Object
// Desc: An object (wall, sprite, item) that vanishes on a trigger
//
//	id- remove object when this is set
//	idle_frames/speed- animation speed and frames in idle animation (0 if none)
//	off_frames/speed- animation played when object is removed.
//
// uses: _id__022 <i,1,163,1,1>
// uses: _idle_frames__022
//	uses: _idle_speed__022
// uses: _off_frames__022
//	uses: _off_speed__022
//
//------------------
// section: ID Values
//	skill1: ID 1
// cntl: spin 1 x 1
// help: ID of trigger that this entity sets/resets.
//
//------------------
// section: Animation
// skill8: IdleFrame 0
// help: Frames of "on" animation
//
// skill9: IdleSpeed 0
// help: Speed to play the "on" animation
//
//------------------
// section: Animation
// skill10: OffFrame 0
// help: Frames of "off" animation
//
// skill11: OffSpeed 0
// help: Speed to play the "off" animation
action	Trigger00_RMObj
{
	var	anim_cnt;   // animation frame

	// cap value to min/max
	if(my._id__022 < 1)  { my._id__022 = 1; }
	if(my._id__022 > (trigger00_max_value_const*trigger00_bitlist_size_const))
	{
		my._id__022 = (trigger00_max_value_const*trigger00_bitlist_size_const);
	}

	wait(3);

	if(my._idle_speed__022 <= 0)
	{
		// no idle animation
		while(Trigger00_Check(my._id__022,trigger00_bitlist) == 0)
		{
			sleep(0.5);
		}
	}
	else
	{
		// idle animation
		anim_cnt = 0;
		while(Trigger00_Check(my._id__022,trigger00_bitlist) == 0)
		{
			anim_cnt += my._idle_speed__022*time_step;
			while(anim_cnt > my._idle_frames__022) { anim_cnt -= my._idle_frames__022; }
			my.frame = anim_cnt;
			wait(1);
		}


	}

	// Trigger has been turned on!

	if(my._off_speed__022 > 0)
	{
		// "off" animation (if any)
		anim_cnt = 0;
		while(anim_cnt < my._off_frames__022)
		{
			anim_cnt += my._off_speed__022 * time_step;
			if(anim_cnt > my._off_frames__022) { anim_cnt = my._off_frames__022; }
			wait(1);
		}
	}

	ent_remove(me);

}

// action: Trigger00_TogObj
// title: Trigger Toggle Object
// Desc: An object (wall, sprite, item) that can toggle on and off on a trigger
//
//	id- add object when this is set
//	idle_frames/speed- animation speed and frames in idle animation (0 if none)
//	on_frames/speed- animation played when object is added.
//	off_frames/speed- animation played when object is removed.
//
// uses: _id__022
// uses: _on_frames__022
//	uses: _on_speed__022
// uses: _idle_frames__022
//	uses: _idle_speed__022
//
//------------------
// section: ID Values
//	skill1: ID 1
// cntl: spin 1 x 1
// help: ID of trigger that this entity sets/resets.
//
//------------------
// section: Animation
// skill6: OnFrame 0
// help: Frames of "on" animation
//
// skill7: OnSpeed 0
// help: Speed to play the "on" animation
//
//------------------
// section: Animation
// skill8: IdleFrame 0
// help: Frames of "on" animation
//
// skill9: IdleSpeed 0
// help: Speed to play the "on" animation
action	Trigger00_TogObj
{
	var	anim_cnt;   // animation frame

	// cap value to min/max
	if(my._id__022 < 1)  { my._id__022 = 1; }
	if(my._id__022 > (trigger00_max_value_const*trigger00_bitlist_size_const))
	{
		my._id__022 = (trigger00_max_value_const*trigger00_bitlist_size_const);
	}

	my.invisible = on;
	my.passable = on;

	wait(3);


	while(1)
	{

		while(Trigger00_Check(my._id__022,trigger00_bitlist) == 0)
		{
			sleep(0.5);
		}

 		// Trigger has been turned on!
		my.invisible = off;
		my.passable = off;

		if(my._on_speed__022 > 0)
		{
			// "off" animation (if any)
			anim_cnt = 0;
			while(anim_cnt < my._on_frames__022)
			{
				anim_cnt += my._on_speed__022 * time_step;
				if(anim_cnt > my._on_frames__022) { anim_cnt = my._on_frames__022; }
				wait(1);
			}
		}

		// Obj ON

		if(my._idle_speed__022 > 0)
		{
			// idle animation
			anim_cnt = 0;
			while(Trigger00_Check(my._id__022,trigger00_bitlist) == 1)
			{
				anim_cnt += my._idle_speed__022*time_step;
				while(anim_cnt > my._idle_frames__022) { anim_cnt -= my._idle_frames__022; }
				my.frame = anim_cnt;
				wait(1);
			}
		}
		else
		{
			while(Trigger00_Check(my._id__022,trigger00_bitlist) == 1)
			{
				sleep(0.5);
			}
		}

 		// Trigger has been turned off!
 		if(my._off_speed__022 > 0)
		{
			// "off" animation (if any)
			anim_cnt = 0;
			while(anim_cnt < my._off_frames__022)
			{
				anim_cnt += my._off_speed__022 * time_step;
				if(anim_cnt > my._off_frames__022) { anim_cnt = my._off_frames__022; }
				wait(1);
			}
		}
		my.invisible = on;
		my.passable = on;


		wait(1);
	}
}



endif; // trigger00_wdl